/*
  R-Bus for Arduino v1.1
  last edition 24.12.2016
*/

#include <RBus2.h>
RBus2Class RBus2;
//
unsigned long currentMicros = 0;
//
bool fbgr1 = false;
bool fbgr0 = false;
bool ReadData = false;

byte XNetMsg0[11]; //Serial receive (Length, Data1 to Data10)
byte XNetMsg1[11]; //Serial receive (Length, Data1 to Data10)
//S E T U P
//------------
void setup() {
  Serial.begin(115200);

  Serial.println("Start R-Bus");

  RBus2.setup(40);    //Initialisierung XNet Serial2 und Send/Receive-PIN pin_40

  currentMicros = micros();
}
//END S E T U P

//L O O P
//------------
void loop() {

// SEND 15E START
//--------------------------------------------------------------------------------------------
  if (fbgr1 == false & fbgr0 == false) {
    for (unsigned int i = 0; i < 1000; i++) {  // 10 SEK
      while ((currentMicros + 8000) > micros()) {
       ; // wait
      }
      currentMicros = micros();
      RBus2.XNetsend1(FB_BROADCAST);
    }
  }
//--------------------------------------------------------------------------------------------


// SEND 1DE GR 1
//--------------------------------------------------------------------------------------------
    unsigned int sendStatus1[] = { G_B, 0xFC, 0x10 };
    while ((currentMicros + 8000) > micros()) {
     ; // wait
    }
    currentMicros = micros();
    XNetclear1();
    RBus2.XNetsend(sendStatus1, 3);
    ReadData = true;
//--------------------------------------------------------------------------------------------

// SEND XOR GR 1
//--------------------------------------------------------------------------------------------
  while ((currentMicros + 7000) > micros()) {
    byte rxdata;
    if (Serial2.available() > 0) {
      rxdata = Serial2.read();
      if (ReadData == true) {           //Data are for own address?
        XNetMsg1[0]++;                  //more news Loading
        XNetMsg1[XNetMsg1[0]] = rxdata; //Enter
      }
    }
  }
  ReadData = false;
  unsigned int sendxorgr1[] = { G_B, 0xFC, 0x10, XNetMsg1[1], XNetMsg1[2], XNetMsg1[3], XNetMsg1[4], XNetMsg1[5], XNetMsg1[6], XNetMsg1[7],XNetMsg1[8], XNetMsg1[9], XNetMsg1[10], 0x00};
  currentMicros = micros();
  unsigned long currentMicros4 = micros();  
  RBus2.getXOR(sendxorgr1, 14);
  if (XNetMsg1[XNetlength] != 0x00) {
    fbgr1 = true;
  }
  else {
    fbgr1 = false;
  }
//--------------------------------------------------------------------------------------------

// SEND 1DE GR 0
//--------------------------------------------------------------------------------------------
  unsigned int sendStatus0[] = { GENERAL_BROADCAST, 0xFC, 0x00 };
  while ((currentMicros + 8000) > micros()) {
   ; // wait
  }
  currentMicros = micros();
  unsigned long currentMicros5 = micros();
  XNetclear0();
  RBus2.XNetsend(sendStatus0, 3);
  ReadData = true;
//--------------------------------------------------------------------------------------------

// SEND XOR GR 0
//--------------------------------------------------------------------------------------------
  while ((currentMicros + 7000) > micros()) {
    byte rxdata;
    if (Serial2.available() > 0) {
      rxdata = Serial2.read();
      if (ReadData == true) {           //Data are for own address?
        XNetMsg0[0]++;                  //more news Loading
        XNetMsg0[XNetMsg0[0]] = rxdata; //Enter
      }
    }
  }
  ReadData = false;
  unsigned int sendxorgr0[] = { GENERAL_BROADCAST, 0xFC, 0x00, XNetMsg0[1], XNetMsg0[2], XNetMsg0[3], XNetMsg0[4], XNetMsg0[5], XNetMsg0[6], XNetMsg0[7],XNetMsg0[8], XNetMsg0[9], XNetMsg0[10], 0x00};
  currentMicros = micros();
  RBus2.getXOR(sendxorgr0, 14);
  if (XNetMsg0[XNetlength] != 0x00) {
   fbgr0 = true;
  }
  else {
    fbgr0 = false;
  }

//--------------------------------------------------------------------------------------------

  Serial.print("Start-1, ");
  Serial.print(XNetMsg0[1], HEX);
  Serial.print(", ");
  Serial.print(XNetMsg0[2], HEX);
  Serial.print(", ");
  Serial.print(XNetMsg0[3], HEX);
  Serial.println(", finish");
  

}
//END LOOP

//--------------------------------------------------------------------------------------------
//Delete the last sent command
void XNetclear0(void) {  //Reset Message
	XNetMsg0[0] = 0x00;	
	XNetMsg0[1] = 0x00;
	XNetMsg0[2] = 0x00;
	XNetMsg0[3] = 0x00;
	XNetMsg0[4] = 0x00;
	XNetMsg0[5] = 0x00;
	XNetMsg0[6] = 0x00;
	XNetMsg0[7] = 0x00;
	XNetMsg0[8] = 0x00;
	XNetMsg0[9] = 0x00;
	XNetMsg0[10] = 0x00;
}

//--------------------------------------------------------------------------------------------
//Delete the last sent command
void XNetclear1(void) {  //Reset Message
	XNetMsg1[0] = 0x00;	
	XNetMsg1[1] = 0x00;
	XNetMsg1[2] = 0x00;
	XNetMsg1[3] = 0x00;
	XNetMsg1[4] = 0x00;
	XNetMsg1[5] = 0x00;
	XNetMsg1[6] = 0x00;
	XNetMsg1[7] = 0x00;
	XNetMsg1[8] = 0x00;
	XNetMsg1[9] = 0x00;
	XNetMsg1[10] = 0x00;
}


